#include <OneWire.h>

int pin_fan=0;
int tmin=2800;
int tmax=5000;
int avgtemp;
int DS18S20_Pin = 1; //DS18S20 Signal pin on digital 1
OneWire ds(DS18S20_Pin); // on digital pin 1

void setup()
{
 TCCR0B = TCCR0B & 0b11111000 | 0b001; //set registers for 31kHz PWM
 pinMode(pin_fan, OUTPUT); //MOSFET pin output
 analogWrite(pin_fan,255); //full on
 delay(600000); //first 10 or so seconds.
}

void loop()
{
 //Serial.println(averageTemperature()); // so we can debug
 avgtemp=abs(getTemp()*100); //read temp from Dallas convert to centi-deg C
 if (avgtemp>tmax) avgtemp=tmax; //keep stuff inside the range
 if (avgtemp<tmin) avgtemp=tmin; //keep stuff inside the range
 
 analogWrite(pin_fan, abs(map(avgtemp,tmin,tmax,32,255))); //set PWM output

 delay(30000); // adjust speed every 500ms ish.
}

//cut & paste warning
float getTemp(){
//returns the temperature from one DS18S20 in DEG Celsius

byte data[12];
byte addr[8];


// error checking
if ( !ds.search(addr)) {
  //no more sensors on chain, reset search
  ds.reset_search();
  return -1000;
}

if ( OneWire::crc8( addr, 7) != addr[7]) {
  //Serial.println("CRC is not valid!");
  return -1000;
}

if ( addr[0] != 0x10 && addr[0] != 0x28) {
  //Serial.print("Device is not recognized");
  return -1000;
}


//read DS
ds.reset();
ds.select(addr);
ds.write(0x44,1); // start conversion, with parasite power on at the end

byte present = ds.reset();
ds.select(addr);
ds.write(0xBE); // Read Scratchpad


for (int i = 0; i < 9; i++) { // we need 9 bytes
data[i] = ds.read();
}

ds.reset_search();

byte MSB = data[1];
byte LSB = data[0];

float tempRead = ((MSB << 8) | LSB); //using two's compliment
float TemperatureSum = tempRead / 16;

return TemperatureSum;

}
